#include <visenv.h>

int sign(long a, long b) {
  return (a>b?1:(a==b?0:-1));
}

void PlotPixel(long col, long row, Pixel color, Image *image) {
  
  int i; // pixel number //

  if(row > image->rows || col > image->cols || row < 0 || col < 0) {    
    printf("pixel out of bounds: col = %ld, row = %ld \n", col, row);
  }
  else{  
    i = (row * image->cols) + col; 
    image->image[i] = color;
  }

} //end PlotPixel

/* Function Definition */
void Line(Point start, Point end, Pixel color, Image *image){
  
  long i, dx, dy;
  float x, y;
  long plotX, plotY;
  long temp, interchange, e;
  long s1, s2;
    
  plotX = start[0];
  plotY = start[1];
  
  dx = abs(end[0] - start[0]);
  dy = abs(end[1] - start[1]); 
  s1 = sign(end[0], start[0]);
  s2 = sign(end[1], start[1]);
  x = start[0] - .5 * s1;
  y = start[1] - .5 * s2;
  
  if( dy > dx ) {
    temp = dx;
    dx = dy;
    dy = temp;
    interchange = 1;
  } else {
    interchange = 0;
  }  
  e = 3 * dy - 2 * dx;
    
  for(i=0; i<dx; i++) {
    PlotPixel(plotX, plotY, color, image);
    while( e > 0 ) {
      if( interchange == 1 ) {
	x = x + s1;
	plotX = x + .5 * s1;
      }
      else {
	y = y + s2;
	plotY = y + .5 * s2;
      }
      e = e - 2 * dx;
    }
    if( interchange == 1 ) {
      y = y + s2;
      plotY = y + .5 * s2;
    }
    else {
      x = x + s1;
      plotX = x + .5 * s1;
    }
    e = e + 2 * dy;
  }
} // end line

void drawBTBox(Box_t box, Pixel color, Image *theImage) {

  Point pt[4];
  int i, j;

  //initialize the points to zero
  for(i=0; i<4; i++) {
    for(j=0; j<4; j++) {
      pt[i][j] = 0.0;
    }
  }

  //top left
  pt[0][0] = (double)box[1]; //left
  pt[0][1] = (double)box[0]; //top

  //top right
  pt[1][0] = (double)box[3]; //right
  pt[1][1] = (double)box[0]; //top

  //bottom left
  pt[2][0] = (double)box[1]; //left
  pt[2][1] = (double)box[2]; //bottom

  //bottom right
  pt[3][0] = (double)box[3]; //right
  pt[3][1] = (double)box[2]; //bottom

  //draw the lines
  Line(pt[0],pt[1],color,theImage);
  Line(pt[1],pt[3],color,theImage);
  Line(pt[3],pt[2],color,theImage);
  Line(pt[2],pt[0],color,theImage);
}
