/*************************************
 * stack.c: functions to work on the
 *          stack structure for D2W
 *          trees
 * Originally written by F. Heckel
 *  to work on queue 02/2002
 * Modified by Jiwon Shin to work
 *  on stack 09/2003
 ************************************/
#include <stack.h>

Stack *initStack( void ){
  Stack * myStack;

  myStack=(Stack *)malloc(sizeof(Stack));
  if(!myStack){
    fprintf(stderr,"Fatal error: out of memory in initStack()\n");
    exit(-1);
  }
  myStack->tail=NULL;

  return myStack;
}

void push(Stack * myStack, long value){
  sNode *myNode, *temp;

  if(myStack->tail==NULL) {
    myNode=(sNode *)malloc(sizeof(sNode));
    myNode->value=value;
    myNode->next=NULL;
    myStack->tail=myNode;
  } else {
    temp = myStack->tail; //point to the first node
    myNode=(sNode *)malloc(sizeof(sNode));
    if(!myNode){
      fprintf(stderr,"Fatal error: out of memory in push()\n");
      exit(-1);
    }
    myNode->value=value;
    //put current node in front of all the nodes
    myNode->next=(struct sNode *)temp;
    myStack->tail=myNode; //point to the first node
  }
}

long pop(Stack * myStack){

  sNode *myNPointer, *temp;
  int myValue;

  if(myStack->tail==NULL) {
    free(myStack);
    fprintf(stderr,"Fatal error: no more elements to pop\n");
    exit(-1);
  }
  else {
    temp = (sNode *)myStack->tail->next;
    myNPointer = myStack->tail;
    myValue = myNPointer->value;
    myStack->tail = temp;
    free(myNPointer);
  }

  return myValue;
}

long stackPeek(Stack * myStack){
  return myStack->tail->value;
}

void sPrint(Stack * myStack){
  
  sNode *myNode=myStack->tail;

  while(myNode){
    printf("Node: %ld\n",myNode->value);
    myNode=(sNode *)myNode->next;
  }

}

bool isEmpty(Stack * myStack){
  if(myStack->tail==NULL){
    return true;
  }
  return false;
}
